Index: s390-tools-sles11/fdasd/fdasd.c
===================================================================
--- s390-tools-sles11.orig/fdasd/fdasd.c
+++ s390-tools-sles11/fdasd/fdasd.c
@@ -12,6 +12,11 @@
 #include "vtoc.h"
 #include "fdasd.h"
 
+/* global variables */
+struct hd_geometry geo;
+char line_buffer[LINE_LENGTH];
+char *line_ptr = line_buffer;
+
 /* Full tool name */
 static const char tool_name[] = "fdasd: zSeries DASD partitioning program";
 
@@ -53,6 +58,45 @@ setpos (fdasd_anchor_t *anc, int dsn, in
 	anc->partno[dsn] = pos;
 }
 
+static u_int32_t get_usable_cylinders(fdasd_anchor_t *anc)
+{
+	u_int32_t cyl;
+
+	/* large volume */
+	if (anc->f4->DS4DEVCT.DS4DSCYL == LV_COMPAT_CYL &&
+	    anc->f4->DS4DCYL > anc->f4->DS4DEVCT.DS4DSCYL)
+		return anc->f4->DS4DCYL;
+	/* normal volume */
+	if (anc->f4->DS4DEVCT.DS4DEVFG & ALTERNATE_CYLINDERS_USED)
+		cyl = anc->f4->DS4DEVCT.DS4DSCYL -
+			(u_int16_t) anc->f4->DS4DEVAC;
+	else
+		cyl = anc->f4->DS4DEVCT.DS4DSCYL;
+	return cyl;
+}
+
+static void get_addr_of_highest_f1_f8_label(fdasd_anchor_t *anc, cchhb_t *addr)
+{
+
+	u_int8_t record;
+	/* We have to count the follwing labels:
+	 * one format 4
+	 * one format 5
+	 * format 7 only if we have moren then BIG_DISK_SIZE tracks
+	 * one for each format 1 or format 8 label == one for each partition
+	 * one for each format 9 label before the last format 8
+	 * We assume that all partitions use format 8 labels when
+	 *  anc->formatted_cylinders > LV_COMPAT_CYL
+	 * Note: Record zero is special, so block 0 on our disk is record 1!
+	 */
+
+	record = anc->used_partitions + 2;
+	if (anc->big_disk)
+		record++;
+	if (anc->formatted_cylinders > LV_COMPAT_CYL)
+		record += anc->used_partitions - 1;
+        vtoc_set_cchhb(addr, VTOC_START_CC, VTOC_START_HH, record);
+}
 
 /* 
  * Check for valid volume serial characters (max. 6) - remove invalid.
@@ -255,18 +299,6 @@ yes_no(char *question_str) 
 
 
 /*
- * converts cyl-cyl-head-head-blk to blk
- */
-static unsigned long
-cchhb2blk (cchhb_t *p) 
-{
-        return (unsigned long) (p->cc * geo.heads * geo.sectors + 
-                                p->hh * geo.sectors +
-                                p->b);
-}
-
-
-/*
  *
  */
 static char *
@@ -370,9 +402,17 @@ fdasd_initialize_anchor (fdasd_anchor_t 
 		fdasd_error(anc, malloc_failed,
 			    "FMT7 DSCB memory allocation failed.");
 
+	/* template for all format 9 labels */
+	anc->f9 = malloc(sizeof(format9_label_t));
+	if (anc->f9 == NULL)
+		fdasd_error(anc, malloc_failed,
+			    "FMT9 DSCB memory allocation failed.");
+
 	bzero(anc->f4, sizeof(format4_label_t));
 	bzero(anc->f5, sizeof(format5_label_t));
 	bzero(anc->f7, sizeof(format7_label_t));
+	bzero(anc->f9, sizeof(format9_label_t));
+	vtoc_init_format9_label(anc->f9);
 
 	vlabel = malloc(sizeof(volume_label_t));
 	if (vlabel == NULL) 
@@ -415,6 +455,8 @@ fdasd_initialize_anchor (fdasd_anchor_t 
 		
 		prev_part_info = part_info;
 	}
+	anc->hw_cylinders = 0;
+	anc->formatted_cylinders = 0;
 }
 
 
@@ -554,7 +596,8 @@ fdasd_parse_conffile(fdasd_anchor_t *anc
 
 		token = strtok(NULL, ",");
 		if (strstr(token, "LAST") != NULL)
-			anc->confdata[i].stop = geo.cylinders * geo.heads - 1;
+			anc->confdata[i].stop = anc->formatted_cylinders
+				* geo.heads - 1;
 		else
 			anc->confdata[i].stop = strtol(token, &stopstring, 10);
 		c1 = c2 + 1;
@@ -585,7 +628,7 @@ fdasd_check_conffile_input (fdasd_anchor
 		if ((start == 0) || (stop == 0)) break;
 
 		first_trk = FIRST_USABLE_TRK;
-		last_trk = geo.cylinders * geo.heads - 1;
+		last_trk = anc->formatted_cylinders * geo.heads - 1;
 
 		if ((start < first_trk) || (start > last_trk)) {
 			snprintf(err_str, ERROR_STRING_SIZE,
@@ -857,7 +900,7 @@ fdasd_list_partition_table (fdasd_anchor
 		       "  tracks per cylinder ..: %d\n"
 		       "  blocks per track .....: %d\n"
 		       "  bytes per block ......: %d\n",
-		       options.device, geo.cylinders, geo.heads, 
+		       options.device, anc->formatted_cylinders, geo.heads,
 		       geo.sectors, anc->blksize);
 
 		vtoc_volume_label_get_label(anc->vlabel, str);
@@ -1010,46 +1053,47 @@ static void
 fdasd_write_vtoc_labels (fdasd_anchor_t *anc) 
 {
         partition_info_t *part_info;
-	unsigned long blk;
+	unsigned long blk, maxblk;
 	char dsno[6], volser[VOLSER_LENGTH + 1], s2[45], *c1, *c2, *ch;
 	int i=0, k=0;
+	cchhb_t f9addr;
+	format1_label_t emptyf1;
 
 	if (!anc->silent) printf("writing VTOC...\n");
 	if (anc->verbose) printf("DSCBs: ");
 
-	blk = (cchhb2blk(&anc->vlabel->vtoc) - 1) * anc->blksize;
+	blk = (cchhb2blk(&anc->vlabel->vtoc, &geo) - 1) * anc->blksize;
 	if (blk <= 0) 
 		fdasd_error(anc, vlabel_corrupted, "");
+	maxblk = blk + anc->blksize * 9; /* f4+f5+f7+3*f8+3*f9 */
 
 	/* write FMT4 DSCB */
-	vtoc_write_label(options.device, blk, NULL, anc->f4, NULL, NULL);
+	vtoc_write_label(options.device, blk, NULL, anc->f4, NULL, NULL, NULL);
 	if (anc->verbose) printf("f4 ");
+	blk += anc->blksize;
 
 	/* write FMT5 DSCB */
-	blk += anc->blksize;
-	vtoc_write_label(options.device, blk, NULL, NULL, anc->f5, NULL);
+	vtoc_write_label(options.device, blk, NULL, NULL, anc->f5, NULL, NULL);
 	if (anc->verbose) printf("f5 ");
+	blk += anc->blksize;
 
 	/* write FMT7 DSCB */
 	if (anc->big_disk) {
-		blk += anc->blksize;
 		vtoc_write_label(options.device, blk,  NULL, NULL,
-				 NULL,anc->f7);
+				 NULL,anc->f7, NULL);
 		if (anc->verbose) printf("f7 ");
+		blk += anc->blksize;
 	}
 
-	/* loop over all FMT1 DSCBs */
+	/* loop over all partitions (format 1 or format 8 DCB) */
 	for (part_info = anc->first; part_info != NULL;
 	     part_info = part_info->next) {
-		blk += anc->blksize; 
-		i++;
 
 		if (part_info->used != 0x01) {
-			vtoc_write_label(options.device, blk, 
-					 part_info->f1, NULL, NULL, NULL);
 			continue;
 		}
 
+		i++;
 		strncpy((char *)part_info->f1->DS1DSSN,	anc->vlabel->volid,
 			VOLSER_LENGTH);
 
@@ -1102,11 +1146,41 @@ fdasd_write_vtoc_labels (fdasd_anchor_t 
 				strncpy(c1, ".NATIVE", 7);
 		}
 		vtoc_ebcdic_enc(ch, ch, 44);
-		if (anc->verbose) printf("f1 ");
+		if (anc->verbose) printf("%2x ", part_info->f1->DS1FMTID);
 
-		vtoc_write_label(options.device, blk, part_info->f1, NULL,
-				 NULL, NULL);
+		if (part_info->f1->DS1FMTID == 0xf8 ) {
+			/* Now as we know where which label will be written, we
+			 * can add the address of the format 9 label to the
+			 * format 8 label. The f9 record will be written to the
+			 * block after the current blk. Remember: records are of
+			 * by one, so we have to add 2 and not just one.
+			 */
+			vtoc_set_cchhb(&f9addr, VTOC_START_CC, VTOC_START_HH,
+				       ((blk / anc->blksize) % geo.sectors) + 2);
+			vtoc_update_format8_label(&f9addr, part_info->f1);
+			vtoc_write_label(options.device, blk, part_info->f1,
+					 NULL, NULL, NULL, NULL);
+			blk += anc->blksize;
+			vtoc_write_label(options.device, blk,  NULL, NULL,
+					 NULL, NULL, anc->f9);
+			if (anc->verbose) printf("f9 ");
+			blk += anc->blksize;
+		} else {
+			vtoc_write_label(options.device, blk, part_info->f1,
+					 NULL, NULL, NULL, NULL);
+			blk += anc->blksize;
+		}
 	}
+
+	/* write empty labels to the rest of the blocks */
+	bzero(&emptyf1, sizeof(emptyf1));
+	while (blk < maxblk) {
+		vtoc_write_label(options.device, blk, &emptyf1, NULL,
+				 NULL, NULL, NULL);
+		if (anc->verbose) printf("empty ");
+		blk += anc->blksize;
+	}
+
 	if (anc->verbose) printf("\n");
 }
 
@@ -1134,34 +1208,22 @@ fdasd_write_labels (fdasd_anchor_t *anc)
 /*
  * re-creates the VTOC and deletes all partitions
  */
-static void
-fdasd_recreate_vtoc(fdasd_anchor_t *anc)
+static void fdasd_recreate_vtoc_unconditional(fdasd_anchor_t *anc)
 {
 	partition_info_t *part_info = anc->first;
-	char str[INPUT_BUF_SIZE];
 	int i;
 
-	if (!anc->silent) {
-		snprintf(str, INPUT_BUF_SIZE, 
-			 "WARNING: All partitions on device '%s' will be "
-			 "deleted!\nDo you want to continue?",
-			 options.device);
-
-		if (yes_no(str) != 0)
-			return;
-
-		printf("creating new VTOC... ");
-	}
-
 	vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS,
-				geo.cylinders, geo.heads, geo.sectors,
+				geo.cylinders, anc->formatted_cylinders,
+				geo.heads, geo.sectors,
 				anc->blksize, anc->dev_type);
 
 	vtoc_init_format5_label(anc->f5);
 	vtoc_init_format7_label(anc->f7);
 	vtoc_set_freespace(anc->f4,anc->f5, anc->f7, '+', anc->verbose,
-			   FIRST_USABLE_TRK, geo.cylinders * geo.heads - 1,
-			   geo.cylinders, geo.heads);
+			   FIRST_USABLE_TRK,
+			   anc->formatted_cylinders * geo.heads - 1,
+			   anc->formatted_cylinders, geo.heads);
 
 	while (part_info != NULL) {
 
@@ -1179,12 +1241,34 @@ fdasd_recreate_vtoc(fdasd_anchor_t *anc)
 	}
 
 	anc->used_partitions = 0;
-	anc->fspace_trk = geo.cylinders * geo.heads - FIRST_USABLE_TRK;
+	anc->fspace_trk = anc->formatted_cylinders * geo.heads
+		- FIRST_USABLE_TRK;
 
 	for (i=0; i<USABLE_PARTITIONS; i++)
 		setpos(anc, i, -1);
 
 	anc->vtoc_changed++;
+}
+
+/*
+ * asks user for confirmation before recreating the vtoc
+ */
+static void fdasd_recreate_vtoc(fdasd_anchor_t *anc)
+{
+	char str[INPUT_BUF_SIZE];
+
+	if (!anc->silent) {
+		snprintf(str, INPUT_BUF_SIZE,
+			 "WARNING: All partitions on device '%s' will be "
+			 "deleted!\nDo you want to continue?",
+			 options.device);
+
+		if (yes_no(str) != 0)
+			return;
+
+		printf("creating new VTOC... ");
+	}
+	fdasd_recreate_vtoc_unconditional(anc);
 	if (!anc->silent) printf("ok\n");
 }
 
@@ -1216,7 +1300,8 @@ fdasd_reuse_vtoc(fdasd_anchor_t *anc)
 	if (!anc->silent) printf("re-creating VTOC... ");
 
 	vtoc_init_format4_label(&f4, USABLE_PARTITIONS,
-				geo.cylinders, geo.heads, geo.sectors,
+				geo.cylinders, anc->formatted_cylinders,
+				geo.heads, geo.sectors,
 				anc->blksize, anc->dev_type);
 
 	/* reuse some FMT4 values */
@@ -1231,7 +1316,7 @@ fdasd_reuse_vtoc(fdasd_anchor_t *anc)
 		vtoc_set_freespace(&f4, &f5, &f7, '+', anc->verbose,
 				   FIRST_USABLE_TRK, 
 				   FIRST_USABLE_TRK + anc->fspace_trk - 1,
-				   geo.cylinders, geo.heads);
+				   anc->formatted_cylinders, geo.heads);
 
 	while (part_info != NULL) {
 		if (part_info->used != 0x01) {
@@ -1239,8 +1324,13 @@ fdasd_reuse_vtoc(fdasd_anchor_t *anc)
 			continue;
 		}
 
-		vtoc_init_format1_label(anc->vlabel->volid, anc->blksize, 
-					&part_info->f1->DS1EXT1, &f1);
+		if (anc->formatted_cylinders > LV_COMPAT_CYL) {
+		    vtoc_init_format8_label(anc->vlabel->volid, anc->blksize,
+					    &part_info->f1->DS1EXT1, &f1);
+		} else
+		    vtoc_init_format1_label(anc->vlabel->volid, anc->blksize,
+					    &part_info->f1->DS1EXT1, &f1);
+
 
 		strncpy(f1.DS1DSNAM, part_info->f1->DS1DSNAM, 44);
 		strncpy((char *)f1.DS1DSSN, (char *)part_info->f1->DS1DSSN, 6);
@@ -1253,7 +1343,7 @@ fdasd_reuse_vtoc(fdasd_anchor_t *anc)
 					   part_info->end_trk + 1, 
 					   part_info->end_trk +
 					   part_info->fspace_trk,
-					   geo.cylinders, geo.heads);
+					   anc->formatted_cylinders, geo.heads);
 
 		part_info = part_info->next;
 	}
@@ -1392,8 +1482,7 @@ fdasd_init_volume_label (fdasd_anchor_t 
 			read_line();
 			fdasd_check_volser(line_ptr, anc->devno);
 			vtoc_volume_label_set_volser(vlabel, line_ptr);
-		} 
-		else {
+		} else {
 			fdasd_check_volser(options.volser, anc->devno);
 			vtoc_volume_label_set_volser(vlabel, options.volser);
 		}
@@ -1415,14 +1504,14 @@ static void
 fdasd_update_partition_info (fdasd_anchor_t *anc) 
 {
         partition_info_t *prev_part_info = NULL, *part_info = anc->first;
-	unsigned int head = geo.heads;
-	unsigned long max = geo.cylinders * head - 1;
+	unsigned long max = anc->formatted_cylinders * geo.heads - 1;
         int i;
 
 	anc->used_partitions = geo.sectors - 2 - anc->f4->DS4DSREC;
 
         for (i=1; i<=USABLE_PARTITIONS; i++) {
-	        if (part_info->f1->DS1FMTID != 0xf1) {
+	        if (part_info->f1->DS1FMTID != 0xf1 &&
+		    part_info->f1->DS1FMTID != 0xf8) {
 		        if (i == 1)
 				/* there is no partition at all */
 				anc->fspace_trk = max - FIRST_USABLE_TRK + 1;
@@ -1435,10 +1524,11 @@ fdasd_update_partition_info (fdasd_ancho
 		
 		/* this is a valid format 1 label */
 		part_info->used = 0x01;
-		part_info->start_trk = part_info->f1->DS1EXT1.llimit.cc * 
-			head + part_info->f1->DS1EXT1.llimit.hh;
-		part_info->end_trk = part_info->f1->DS1EXT1.ulimit.cc * head +
-			part_info->f1->DS1EXT1.ulimit.hh;
+		part_info->start_trk = cchh2trk(&part_info->f1->DS1EXT1.llimit,
+						&geo);
+		part_info->end_trk = cchh2trk(&part_info->f1->DS1EXT1.ulimit,
+					      &geo);
+
 		part_info->len_trk = part_info->end_trk -
 			part_info->start_trk + 1;
 		
@@ -1494,15 +1584,29 @@ static void
 fdasd_process_invalid_vtoc(fdasd_anchor_t *anc)
 {
 	printf(" invalid\ncreating new VTOC...\n");
+	if (anc->hw_cylinders > LV_COMPAT_CYL) {
+		printf("Warning: Device has more then %u cylinders!\n",
+			       LV_COMPAT_CYL);
+		if (yes_no("Are you sure it was completely"
+			   " formatted with dasdfmt?") == 1) {
+			if (!anc->silent) printf("exiting...\n");
+			fdasd_exit(anc, 0);
+		}
+	}
+	anc->formatted_cylinders = anc->hw_cylinders;
+	anc->fspace_trk = anc->formatted_cylinders * geo.heads
+		- FIRST_USABLE_TRK;
 	vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS,
-				geo.cylinders, geo.heads, geo.sectors,
+				geo.cylinders, anc->formatted_cylinders,
+				geo.heads, geo.sectors,
 				anc->blksize, anc->dev_type);
 
 	vtoc_init_format5_label(anc->f5);
 	vtoc_init_format7_label(anc->f7);
 	vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+', anc->verbose,
-			   FIRST_USABLE_TRK, geo.cylinders * geo.heads - 1,
-			   geo.cylinders, geo.heads);
+			   FIRST_USABLE_TRK,
+			   anc->formatted_cylinders * geo.heads - 1,
+			   anc->formatted_cylinders, geo.heads);
 
 	anc->vtoc_changed++;
 }
@@ -1521,8 +1625,21 @@ fdasd_process_valid_vtoc(fdasd_anchor_t 
 	char part_no_str[5], *part_pos;
 
 	if (!anc->silent) printf(" ok\n");
+
+	if (anc->f4->DS4DEVCT.DS4DSCYL == LV_COMPAT_CYL &&
+	    anc->f4->DS4DCYL > anc->f4->DS4DEVCT.DS4DSCYL)
+		anc->formatted_cylinders = anc->f4->DS4DCYL;
+	else
+		anc->formatted_cylinders = anc->f4->DS4DEVCT.DS4DSCYL;
+	anc->fspace_trk = anc->formatted_cylinders * geo.heads
+		- FIRST_USABLE_TRK;
 	blk += anc->blksize;
 
+	if (anc->formatted_cylinders < anc->hw_cylinders)
+		printf("WARNING: This device is not fully formatted! "
+		       "Only %u of %u cylinders are available.\n",
+		       anc->formatted_cylinders, anc->hw_cylinders);
+
 	if (anc->verbose) printf("VTOC DSCBs          : ");
 
 	for (i = 1; i <= geo.sectors; i++) {
@@ -1532,8 +1649,11 @@ fdasd_process_valid_vtoc(fdasd_anchor_t 
 
 		switch (f1_label.DS1FMTID) {
 		case 0xf1:
-			if (anc->verbose) printf("f1 ");
-			if(part_info == NULL) break;
+		case 0xf8:
+			if (anc->verbose)
+				printf("%s ",
+				       f1_label.DS1FMTID == 0xf1 ? "f1" : "f8");
+			if (part_info == NULL) break;
 			memcpy(part_info->f1, &f1_label, f1_size);
 
 			part_no = -1;
@@ -1572,6 +1692,12 @@ fdasd_process_valid_vtoc(fdasd_anchor_t 
 				memcpy(anc->f7, &f1_label, f1_size);
 			f7_counter++;
 			break;
+		case 0xf9:
+			/* each format 8 lable has an associated format 9 lable,
+                         * but they are of no further use to us.
+			 */
+			if (anc->verbose) printf("f9 ");
+			break;
 		default: 
 			if (f1_label.DS1FMTID > 0)
 				printf("'%d' is not supported!\n", 
@@ -1614,30 +1740,9 @@ fdasd_valid_vtoc_pointer(fdasd_anchor_t 
 		}
 		fdasd_process_invalid_vtoc(anc);
 	}
-	else 
+	else
 		fdasd_process_valid_vtoc(anc, blk);
 
-	/* change volume serial? */
-	if (options.volser && !anc->print_table) {
-		char volser[VOLSER_LENGTH + 1];
-
-		vtoc_volume_label_get_volser(anc->vlabel, volser);
-		volser[VOLSER_LENGTH] = 0x00;
-
-		fdasd_check_volser(options.volser, anc->devno);
-
-		snprintf(str, INPUT_BUF_SIZE,
-			"Overwrite existing volume serial '%-6s'\n"
-			"with new volume serial '%-6s'?", 
-			volser, options.volser);
-
-		if (yes_no(str) != 0)
-			return 0;
-		
-		vtoc_volume_label_set_volser(anc->vlabel, options.volser);
-		anc->vlabel_changed++;
-		anc->vtoc_changed++;
-	}
 	return 0;
 }
 
@@ -1654,16 +1759,30 @@ fdasd_invalid_vtoc_pointer(fdasd_anchor_
 		fdasd_exit(anc, 0);
 	}
 
-	vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS, 
-				geo.cylinders, geo.heads, geo.sectors, 
+	if (anc->hw_cylinders > LV_COMPAT_CYL) {
+		printf("Warning: Device has more then %u cylinders!\n",
+			       LV_COMPAT_CYL);
+		if (yes_no("Are you sure it was completely"
+			   " formatted with dasdfmt?") == 1) {
+			if (!anc->silent) printf("exiting...\n");
+			fdasd_exit(anc, 0);
+		}
+	}
+	anc->formatted_cylinders = anc->hw_cylinders;
+	anc->fspace_trk = anc->formatted_cylinders * geo.heads
+		- FIRST_USABLE_TRK;
+	vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS,
+				geo.cylinders, anc->formatted_cylinders,
+				geo.heads, geo.sectors,
 				anc->blksize, anc->dev_type);
 
 	vtoc_init_format5_label(anc->f5);
 	vtoc_init_format7_label(anc->f7);
 
 	vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+', anc->verbose,
-			   FIRST_USABLE_TRK, geo.cylinders * geo.heads - 1,
-			   geo.cylinders, geo.heads);
+			   FIRST_USABLE_TRK,
+			   anc->formatted_cylinders * geo.heads - 1,
+			   anc->formatted_cylinders, geo.heads);
 
 	vtoc_set_cchhb(&anc->vlabel->vtoc, VTOC_START_CC, VTOC_START_HH, 0x01);
 
@@ -1679,7 +1798,7 @@ static int
 fdasd_check_volume (fdasd_anchor_t *anc) 
 {
 	volume_label_t *vlabel = anc->vlabel;
-        unsigned long blk = -1;
+        long long blk = -1;
 	char str[LINE_LENGTH];
 	char inp_buf[INPUT_BUF_SIZE];
 
@@ -1693,7 +1812,7 @@ fdasd_check_volume (fdasd_anchor_t *anc)
 		if (!anc->silent)
 			printf(" VOL1\n");
 
-		blk = (cchhb2blk(&vlabel->vtoc) - 1) * anc->blksize;
+		blk = (cchhb2blk(&vlabel->vtoc, &geo) - 1) * anc->blksize;
 		if (blk > 0) {
 			int rc;
 			rc = fdasd_valid_vtoc_pointer(anc, blk);
@@ -1708,8 +1827,7 @@ fdasd_check_volume (fdasd_anchor_t *anc)
 			}
 			fdasd_invalid_vtoc_pointer(anc);
 		}
-	}
-	else {
+	} else {
 	        /* didn't find VOL1 volume label */
 
 		if (anc->print_table) {
@@ -1734,19 +1852,33 @@ fdasd_check_volume (fdasd_anchor_t *anc)
 		               "partitioning\nexiting...\n");
 			fdasd_exit(anc, -1);
                 }
+
+		if (anc->hw_cylinders > LV_COMPAT_CYL) {
+			printf("Warning: Device has more then %u cylinders!\n",
+			       LV_COMPAT_CYL);
+			if (yes_no("Are you sure it was completely"
+				   " formatted with dasdfmt?") == 1) {
+				if (!anc->silent) printf("exiting...\n");
+				fdasd_exit(anc, 0);
+			}
+		}
+		anc->formatted_cylinders = anc->hw_cylinders;
+		anc->fspace_trk = anc->formatted_cylinders * geo.heads - FIRST_USABLE_TRK;
+
 		fdasd_init_volume_label(anc);
 
 		vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS,
-					geo.cylinders, geo.heads, geo.sectors,
+					geo.cylinders, anc->formatted_cylinders,
+					geo.heads, geo.sectors,
 					anc->blksize, anc->dev_type);
 
 		vtoc_init_format5_label(anc->f5);
 		vtoc_init_format7_label(anc->f7);
 
-		vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+', 
-				   anc->verbose, FIRST_USABLE_TRK, 
-				   geo.cylinders * geo.heads - 1,
-				   geo.cylinders, geo.heads);
+		vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+',
+				   anc->verbose, FIRST_USABLE_TRK,
+				   anc->formatted_cylinders * geo.heads - 1,
+				   anc->formatted_cylinders, geo.heads);
 
 		anc->vtoc_changed++;
 	}
@@ -1823,6 +1955,7 @@ fdasd_get_geometry (fdasd_anchor_t *anc)
         int fd, blksize = 0;
 	dasd_information_t dasd_info;
 	char err_str[ERROR_STRING_SIZE];
+	u_int64_t device_size;
 
 	if ((fd = open(options.device,O_RDONLY)) < 0) {
 		snprintf(err_str, ERROR_STRING_SIZE,
@@ -1843,6 +1976,14 @@ fdasd_get_geometry (fdasd_anchor_t *anc)
 			    "Could not retrieve blocksize information.");
 	}
 
+	if (ioctl(fd, BLKGETSIZE64, &device_size) != 0) {
+	        close(fd);
+	        fdasd_error(anc, unable_to_ioctl,
+			    "Could not retrieve device size information.");
+	}
+
+	anc->hw_cylinders = ((device_size / blksize) / geo.sectors) / geo.heads;
+
 	/* get disk type */
 	if (ioctl(fd, BIODASDINFO, &dasd_info) != 0) {
 	        close(fd);
@@ -1891,7 +2032,6 @@ fdasd_get_geometry (fdasd_anchor_t *anc)
 	anc->blksize    = blksize;
 	anc->label_pos  = dasd_info.label_block * blksize;
 	anc->devno      = dasd_info.devno;
-	anc->fspace_trk = geo.cylinders * geo.heads - FIRST_USABLE_TRK;
 }
 
 
@@ -2025,20 +2165,16 @@ fdasd_get_partition_data (fdasd_anchor_t
 			  partition_info_t *part_info) 
 {
 	unsigned long start, stop, limit;
-	unsigned int cc, hh;
+	u_int32_t cc, cyl;
+	u_int16_t hh, head;
 	cchh_t llimit,ulimit;
 	partition_info_t *part_tmp;
         char mesg[48];
 	u_int8_t b1, b2;
-	u_int16_t cyl, head;
 
 	start = FIRST_USABLE_TRK;
-	if (anc->f4->DS4DEVCT.DS4DEVFG & ALTERNATE_CYLINDERS_USED)
-		cyl = anc->f4->DS4DEVCT.DS4DSCYL - 
-			(u_int16_t) anc->f4->DS4DEVAC;
-	else
-		cyl = anc->f4->DS4DEVCT.DS4DSCYL;
 
+ 	cyl = get_usable_cylinders(anc);
 	head = anc->f4->DS4DEVCT.DS4DSTRK;
 	limit = (head * cyl - 1);
 
@@ -2254,7 +2390,6 @@ fdasd_add_partition (fdasd_anchor_t *anc
 	partition_info_t *part_info;
 	extent_t ext;
 	unsigned long start, stop;
-	int i;
 
 	if ((part_info = fdasd_get_empty_f1_label(anc)) == NULL) {
 	        printf("No more free partitions left,\n"
@@ -2264,22 +2399,25 @@ fdasd_add_partition (fdasd_anchor_t *anc
 
 	if (fdasd_get_partition_data(anc, &ext, part_info) != 0)
 	        return;
-	vtoc_init_format1_label(anc->vlabel->volid, anc->blksize, &ext,
-				part_info->f1);
+
+	if (anc->formatted_cylinders > LV_COMPAT_CYL) {
+		vtoc_init_format8_label(anc->vlabel->volid, anc->blksize, &ext,
+					part_info->f1);
+	} else
+		vtoc_init_format1_label(anc->vlabel->volid, anc->blksize, &ext,
+					 part_info->f1);
+
 	fdasd_enqueue_new_partition(anc);
 	anc->used_partitions += 1;
 
-	i = anc->used_partitions + 2;
-	if (anc->big_disk) i++;
-
-        vtoc_set_cchhb(&hf1, VTOC_START_CC, VTOC_START_HH, i);
+	get_addr_of_highest_f1_f8_label(anc, &hf1);
 	vtoc_update_format4_label(anc->f4, &hf1, anc->f4->DS4DSREC - 1);
 
-	start = ext.llimit.cc * geo.heads + ext.llimit.hh;
-	stop  = ext.ulimit.cc * geo.heads + ext.ulimit.hh;
+	start = cchh2trk(&ext.llimit, &geo);
+	stop = cchh2trk(&ext.ulimit, &geo);
 
 	vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '-', anc->verbose,
-			   start, stop, geo.cylinders, geo.heads);
+			   start, stop, anc->formatted_cylinders, geo.heads);
 
 	anc->vtoc_changed++;
 }
@@ -2316,26 +2454,20 @@ fdasd_remove_partition (fdasd_anchor_t *
 	setpos(anc, part_id-1, -1);
 	for (i=1; i<part_id; i++) part_info=part_info->next;
 
-	start = part_info->f1->DS1EXT1.llimit.cc * geo.heads + 
-		part_info->f1->DS1EXT1.llimit.hh;
-	stop  = part_info->f1->DS1EXT1.ulimit.cc * geo.heads + 
-		part_info->f1->DS1EXT1.ulimit.hh;
+	start = cchh2trk(&part_info->f1->DS1EXT1.llimit, &geo);
+	stop  = cchh2trk(&part_info->f1->DS1EXT1.ulimit, &geo);
 
 	fdasd_dequeue_old_partition (anc, part_info, part_id-1);
 	anc->used_partitions -= 1;
 
-	if (anc->used_partitions != 0) {
-		i = anc->used_partitions + 2;
-		if (anc->big_disk) i++;
-
-        	vtoc_set_cchhb(&hf1, VTOC_START_CC, VTOC_START_HH, i);
-	}
+	if (anc->used_partitions != 0)
+		get_addr_of_highest_f1_f8_label(anc, &hf1);
 	else
 		bzero(&hf1, sizeof(struct cchhb));
 
 	vtoc_update_format4_label(anc->f4, &hf1, anc->f4->DS4DSREC + 1);
 	vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+', anc->verbose,
-			   start, stop, geo.cylinders, geo.heads);
+			   start, stop, anc->formatted_cylinders, geo.heads);
 
 	anc->vtoc_changed++;
 }
@@ -2356,8 +2488,8 @@ fdasd_auto_partition(fdasd_anchor_t *anc
 	cchhb_t hf1;
 	extent_t ext;
 	char volser[VOLSER_LENGTH + 1];
-	u_int16_t cyl, head;
-	int i;
+	u_int32_t cyl;
+	u_int16_t head;
 	char old_volser[VOLSER_LENGTH + 1];
 
 	if (!anc->silent)
@@ -2390,18 +2522,14 @@ fdasd_auto_partition(fdasd_anchor_t *anc
 
 	if (anc->verbose) printf("initializing labels...\n");
 	vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS,
-				geo.cylinders, geo.heads, geo.sectors,
+				geo.cylinders, anc->formatted_cylinders,
+				geo.heads, geo.sectors,
 				anc->blksize, anc->dev_type);
 
 	vtoc_init_format5_label(anc->f5);
 	vtoc_init_format7_label(anc->f7);
 
-	if (anc->f4->DS4DEVCT.DS4DEVFG & ALTERNATE_CYLINDERS_USED)
-		cyl = anc->f4->DS4DEVCT.DS4DSCYL -
-			(u_int16_t) anc->f4->DS4DEVAC;
-	else
-		cyl = anc->f4->DS4DEVCT.DS4DSCYL;
-
+	cyl = get_usable_cylinders(anc);
 	head = anc->f4->DS4DEVCT.DS4DSTRK;
 
 	part_info->used       = 0x01;
@@ -2415,22 +2543,23 @@ fdasd_auto_partition(fdasd_anchor_t *anc
 
 	vtoc_set_extent(&ext, 0x01, 0x00, &llimit, &ulimit);
 
-	vtoc_init_format1_label(anc->vlabel->volid, anc->blksize, &ext,
-				part_info->f1);
-	i = 3;
-	if (anc->big_disk) i++;
-
-        vtoc_set_cchhb(&hf1, VTOC_START_CC, VTOC_START_HH, i);
-	vtoc_update_format4_label(anc->f4, &hf1, anc->f4->DS4DSREC - 1);
-
+	if (anc->formatted_cylinders > LV_COMPAT_CYL) {
+		vtoc_init_format8_label(anc->vlabel->volid, anc->blksize, &ext,
+					part_info->f1);
+	} else
+		vtoc_init_format1_label(anc->vlabel->volid, anc->blksize, &ext,
+					part_info->f1);
         anc->fspace_trk      = 0;
 	anc->used_partitions = 1;
 
+	get_addr_of_highest_f1_f8_label(anc, &hf1);
+	vtoc_update_format4_label(anc->f4, &hf1, anc->f4->DS4DSREC - 1);
+
 	anc->vlabel_changed++;
 	anc->vtoc_changed++;
 
 	fdasd_write_labels(anc);
-	fdasd_exit(anc, 0);		    
+	fdasd_exit(anc, 0);
 }
 
 
@@ -2443,7 +2572,6 @@ fdasd_auto_partition_conffile(fdasd_anch
 	volume_label_t *vlabel = anc->vlabel;
 	partition_info_t *part_info = anc->first;
 	char volser[VOLSER_LENGTH + 1];
-	int i;
 	cchh_t llimit,ulimit;
 	unsigned long start, stop;
 	extent_t ext;
@@ -2477,7 +2605,8 @@ fdasd_auto_partition_conffile(fdasd_anch
 
 	if (anc->verbose) printf("initializing labels...\n");
 	vtoc_init_format4_label(anc->f4, USABLE_PARTITIONS,
-				geo.cylinders, geo.heads, geo.sectors,
+				geo.cylinders, anc->formatted_cylinders,
+				geo.heads, geo.sectors,
 				anc->blksize, anc->dev_type);
 
 	vtoc_init_format5_label(anc->f5);
@@ -2486,10 +2615,10 @@ fdasd_auto_partition_conffile(fdasd_anch
 	if (anc->fspace_trk != 0) {
 		start = FIRST_USABLE_TRK;
 		stop  = start + anc->fspace_trk - 1;
-				
-		vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+', 
+
+		vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+',
 				   anc->verbose, start, stop,
-				   geo.cylinders, geo.heads);
+				   anc->formatted_cylinders, geo.heads);
 	}
 
 	do {
@@ -2497,35 +2626,35 @@ fdasd_auto_partition_conffile(fdasd_anch
 			continue;
 
 		vtoc_set_cchh(&llimit,
-			      part_info->start_trk / geo.heads, 
+			      part_info->start_trk / geo.heads,
 			      part_info->start_trk % geo.heads);
-		vtoc_set_cchh(&ulimit, 
-			      part_info->end_trk / geo.heads, 
+		vtoc_set_cchh(&ulimit,
+			      part_info->end_trk / geo.heads,
 			      part_info->end_trk % geo.heads);
 
-		vtoc_set_extent(&ext, (llimit.hh == 0 ? 0x81 : 0x01), 
+		vtoc_set_extent(&ext, (vtoc_get_head_from_cchh(&llimit) == 0
+				       ? 0x81 : 0x01),
 				0x00, &llimit, &ulimit);
 
-		vtoc_init_format1_label(vlabel->volid,
-					anc->blksize, &ext, part_info->f1);
-
+		if (anc->formatted_cylinders > LV_COMPAT_CYL) {
+			vtoc_init_format8_label(vlabel->volid, anc->blksize,
+						&ext, part_info->f1);
+		} else
+			vtoc_init_format1_label(vlabel->volid, anc->blksize,
+						&ext, part_info->f1);
 		anc->used_partitions += 1;
 
-		i = anc->used_partitions + 2;
-		if (anc->big_disk) i++;
-
-		vtoc_set_cchhb(&hf1, VTOC_START_CC, VTOC_START_HH, i);
-
+		get_addr_of_highest_f1_f8_label(anc, &hf1);
 		vtoc_update_format4_label(anc->f4, &hf1,anc->f4->DS4DSREC - 1);
 
 		/* update free space labels */
 		if (part_info->fspace_trk != 0) {
 			start = part_info->end_trk + 1;
 			stop  = start + part_info->fspace_trk -1;
-				
+
 			vtoc_set_freespace(anc->f4, anc->f5, anc->f7, '+', 
 					   anc->verbose, start, stop,
-					   geo.cylinders, geo.heads);
+					   anc->formatted_cylinders, geo.heads);
 		}
 	} while ((part_info = part_info->next) != NULL);
 
@@ -2577,20 +2706,24 @@ main(int argc, char *argv[]) 
 	fdasd_get_geometry(&anchor);
 	fdasd_check_disk_access(&anchor);
 
-	if ((geo.cylinders * geo.heads) > BIG_DISK_SIZE) anchor.big_disk++;
+	/* check dasd for labels and vtoc */
+	rc = fdasd_check_volume(&anchor);
+
+	if ((anchor.formatted_cylinders * geo.heads) > BIG_DISK_SIZE)
+		anchor.big_disk++;
 
-	if (anchor.auto_partition)
+	if (anchor.auto_partition) {
+		fdasd_recreate_vtoc_unconditional(&anchor);
 		fdasd_auto_partition(&anchor);
+	}
 
 	if (options.conffile) {
+		fdasd_recreate_vtoc_unconditional(&anchor);
 		fdasd_parse_conffile(&anchor, &options);
 		fdasd_check_conffile_input(&anchor, &options);
 		fdasd_auto_partition_conffile(&anchor);
 	}
 
-	/* check dasd for labels and vtoc */
-	rc = fdasd_check_volume(&anchor);
-
 	if (anchor.print_table) {
 		if (rc == 0)
 			fdasd_list_partition_table(&anchor);
Index: s390-tools-sles11/fdasd/fdasd.h
===================================================================
--- s390-tools-sles11.orig/fdasd/fdasd.h
+++ s390-tools-sles11/fdasd/fdasd.h
@@ -48,25 +48,15 @@ typedef struct dasd_information_t {
 
 
 /*****************************************************************************
- * SECTION: Further IOCTL Definitions  (see fs.h)                            *
+ * SECTION: Further IOCTL Definitions  (see fs.h and hdreq.h)                *
  *****************************************************************************/
 #define BLKROGET   _IO(0x12,94) /* get read-only status (0 = read_write) */
 #define BLKRRPART  _IO(0x12,95) /* re-read partition table */
 #define BLKSSZGET  _IO(0x12,104)/* get block device sector size */
-
-/*****************************************************************************
- * SECTION: Definition from hdreq.h                                          *
- *****************************************************************************/
-
-struct hd_geometry {
-      unsigned char heads;
-      unsigned char sectors;
-      unsigned short cylinders;
-      unsigned long start;
-};
+#define BLKGETSIZE64 _IOR(0x12,114,size_t) /* device size in bytes (u64 *arg)*/
 
 /* get device geometry */
-#define HDIO_GETGEO		0x0301	
+#define HDIO_GETGEO		0x0301
 
 /*****************************************************************************
  * SECTION: FDASD internal types                                             *
@@ -119,7 +109,7 @@ typedef struct partition_info {
         unsigned long      end_trk;
         unsigned long      len_trk;
         unsigned long      fspace_trk;
-        format1_label_t  * f1; 
+        format1_label_t  * f1;
         struct partition_info *next;
         struct partition_info *prev;
 } partition_info_t;
@@ -153,10 +143,13 @@ typedef struct fdasd_anchor {
         format4_label_t  *f4;
         format5_label_t  *f5;
 	format7_label_t  *f7;
+	format9_label_t  *f9; /* template for all f9 labels */
         partition_info_t *first;
         partition_info_t *last;
         volume_label_t   *vlabel;
 	config_data_t confdata[USABLE_PARTITIONS];
+	u_int32_t hw_cylinders;
+	u_int32_t formatted_cylinders;
 } fdasd_anchor_t;
 
 enum offset {lower, upper};
@@ -179,11 +172,6 @@ enum fdasd_failure {
 	volser_not_found
 };
 
-/* global variables */
-struct hd_geometry geo;
-char line_buffer[LINE_LENGTH];
-char *line_ptr = line_buffer;
-
 #define ERROR_STRING_SIZE 1024
 #define INPUT_BUF_SIZE 1024
 
